searchData={"content_type":"text/markdown","items":[{"doc":"Überauth strategy for Mastodon and Pleroma.","ref":"Ueberauth.Strategy.Mastodon.html","title":"Ueberauth.Strategy.Mastodon","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.Mastodon.html#default_options/0","title":"Ueberauth.Strategy.Mastodon.default_options/0","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Mastodon.API.html","title":"Ueberauth.Strategy.Mastodon.API","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.Mastodon.API.html#account_verify_credentials/2","title":"Ueberauth.Strategy.Mastodon.API.account_verify_credentials/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Mastodon.API.html#app_create/2","title":"Ueberauth.Strategy.Mastodon.API.app_create/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Mastodon.API.html#build_authorize_url/2","title":"Ueberauth.Strategy.Mastodon.API.build_authorize_url/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Mastodon.API.html#token_create/2","title":"Ueberauth.Strategy.Mastodon.API.token_create/2","type":"function"},{"doc":"Parses configuration secrets at runtime.","ref":"Ueberauth.Strategy.Mastodon.OptionsParser.html","title":"Ueberauth.Strategy.Mastodon.OptionsParser","type":"module"},{"doc":"Similar to `Ueberauth.Strategy.Helpers.options/1` except it also\nparses secrets with `Ueberauth.Strategy.Mastodon.Secret.parse_secret/1`\n\nIf any required options are missing or invalid, it will raise.","ref":"Ueberauth.Strategy.Mastodon.OptionsParser.html#from_conn!/1","title":"Ueberauth.Strategy.Mastodon.OptionsParser.from_conn!/1","type":"function"},{"doc":"Functions for dealing with configuration secrets.","ref":"Ueberauth.Strategy.Mastodon.Secret.html","title":"Ueberauth.Strategy.Mastodon.Secret","type":"module"},{"doc":"Accepts a `t:secret/0` and returns a tuple with the parsed string.\nUseful for runtime configuration.\n\nExample:\n\n```elixir\niex(1)> parse_secret({System, :get_env, [\"SECRET_KEY\"]})\n{:ok, \"12345678\"}\niex(2)> parse_secret(nil)\n{:error, nil}\n```","ref":"Ueberauth.Strategy.Mastodon.Secret.html#parse_secret/1","title":"Ueberauth.Strategy.Mastodon.Secret.parse_secret/1","type":"function"},{"doc":"Tuple in the form `{module, function_name, args}`.\nParsed into a string at runtime.\n\nExample:\n\n```elixir\n{System, :get_env, [\"SECRET_KEY\"]}\n```","ref":"Ueberauth.Strategy.Mastodon.Secret.html#t:mfa_secret/0","title":"Ueberauth.Strategy.Mastodon.Secret.mfa_secret/0","type":"type"},{"doc":"A configuration secret.\nEither a `t:mfa_secret/0`, a function, or a string.","ref":"Ueberauth.Strategy.Mastodon.Secret.html#t:secret/0","title":"Ueberauth.Strategy.Mastodon.Secret.secret/0","type":"type"},{"doc":"# ueberauth_mastodon\n\nLog into [Mastodon](https://joinmastodon.org/) and [Pleroma](https://pleroma.social/) with [Überauth](https://github.com/ueberauth/ueberauth).\n\nThis library makes it easy to spin up Elixir microservices to run alongside your social media website.\n\nYou can configure one or more Mastodon/Pleroma servers as login options.","ref":"readme.html","title":"ueberauth_mastodon","type":"extras"},{"doc":"","ref":"readme.html#usage-guide","title":"Usage guide - ueberauth_mastodon","type":"extras"},{"doc":"```elixir\n# Tesla\nconfig :tesla, adapter: Tesla.Adapter.Hackney\n\n# Ueberauth\nconfig :ueberauth, Ueberauth,\n  providers: [\n    # You will create routes matching the provider name:\n    # - /auth/mastodon\n    # - /auth/mastodon/callback\n    mastodon: {Ueberauth.Strategy.Mastodon, [\n      # instance: \"https://example.tld\",\n      # client_id: \"********\",\n      # client_secret: \"********\",\n      # scope: \"read write follow\"\n    ]},\n\n    # This one will be at /auth/gleasonator\n    gleasonator:\n      {Ueberauth.Strategy.Mastodon,\n       [\n         # You MUST provide an instance.\n         instance: \"https://gleasonator.com\",\n         # You MUST provide app credentials.\n         # Generate your app before getting started.\n         client_id: \"3WCR-5e3nOg2SJ90W134VLIIwmib2T96qsXWSJAAEUs\",\n         client_secret: \"r-vCWcOk_7IY202yYMMgEHEVEtd5Gv4tlByZqVChRm0\",\n         scope: \"read write follow\"\n       ]}\n  ]\n```\n\n#### Tesla\n\nUnder the hood, ueberauth_mastodon uses [Tesla](https://github.com/teamon/tesla) to make HTTP requests.\n\nTesla is not an HTTP client itself, but a flexible layer for switchable HTTP clients.\nIn this guide we use Hackney, but you can use whatever you want.\nJust don't leave it blank.\n\n##### Options\n\n- `instance` (**required**) - A URL to the Mastodon/Pleroma instance.\n- `client_id` (**required**) - Generated by an app. Create the app first.\n- `client_secret` (**required**) - Generated by an app. Create the app first.\n- `scope` - Space-separated list of scopes, eg `read write follow`. It defaults to `read`.\n\n###### Advanced\n\n- `redirect_uri` - Override the redirect URL. By default it goes to `/auth/:provider/callback`\n- `uid_field` - Which field from Mastodon API to map to Überauth. It's set to `\"url\"` (the ActivityPub ID) by default.\n\n##### Runtime configuration\n\nAll configuration options are strings.\nFor runtime configuration, it's possible to pass values that will be evaulated to strings:\n\n- **string**, eg `\"123456\"`\n- **{m, f, a}** tuple, eg `{System, :get_env, [\"CLIENT_SECRET\"]}`\n- **function**, eg `fn -> System.get_env(\"CLIENT_SECRET\") end`\n\n```elixir\n# Runtime configuration\nconfig :ueberauth, Ueberauth,\n  providers: [\n    mastodon: {Ueberauth.Strategy.Mastodon, [\n\n      # Just a plain old hardcoded string\n      instance: \"https://example.tld\",\n\n      # {module, function, args} format\n      client_id: {System, :get_env, \"MASTODON_CLIENT_ID\"},\n\n      # Anonymous function\n      client_secret: fn -> System.get_env(\"MASTODON_CLIENT_SECRET\") end\n    ]}\n  ]\n```","ref":"readme.html#configuration","title":"Configuration - ueberauth_mastodon","type":"extras"},{"doc":"You'll need to create matching routes in `router.ex`:\n\n```elixir\nscope \"/auth\", PatronWeb do\n  pipe_through [:browser, Ueberauth]\n\n  get \"/mastodon\", AuthController, :request\n  get \"/mastodon/callback\", AuthController, :callback\n\n  # You don't have to have more than one, but you can have any number\n  get \"/gleasonator\", AuthController, :request\n  get \"/gleasonator/callback\", AuthController, :callback\nend\n```\n\nThe `Ueberauth` plug will match names from your config and intercept the conn before it arrives at your controller.\n\n#### request/2\n\nYou **do not** need to implement the `request/2` view in your controller. The plug intercepts it and does a redirect before it hits your controller.\n\nJust put a link to `/auth/:provider` somewhere on your website, and it will redirect to the OAuth signup page.\n\n#### callback/2\n\nYou **must** provide a `callback/2` view.\n\n```elixir\ndef callback(%{assigns: %{ueberauth_auth: auth}} = conn, _params) do\n  # TODO: Store the auth somewhere\n  conn\nend\n```","ref":"readme.html#routes","title":"Routes - ueberauth_mastodon","type":"extras"},{"doc":"You'll need to create a controller to handle the callback.\nBelow is an example of a full controller.\n\n```elixir\ndefmodule PatronWeb.AuthController do\n  use PatronWeb, :controller\n\n  alias Ueberauth.Auth\n  alias Ueberauth.Auth.Credentials\n  alias Ueberauth.Failure\n  alias Ueberauth.Failure.Error\n\n  # /auth/:provider/callback\n  # After the user authorizes the OAuth form, they'll be redirected back here.\n  def callback(\n        # An `:ueberauth_auth` key is provided upon success.\n        # It contains a `%Ueberauth.Auth{}` struct.\n        # https://hexdocs.pm/ueberauth/Ueberauth.Auth.html#t:t/0\n        %{assigns: %{ueberauth_auth: %Auth{uid: uid, credentials: %Credentials{} = credentials}}} = conn,\n        _params\n      ) do\n    conn\n    # Store the credentials in a cookie, or anywhere else\n    |> put_session(:token_data, credentials)\n    |> put_session(:uid, uid)\n    |> redirect(to: \"/\")\n  end\n\n  def callback(\n        # Upon failure, you'll get `:ueberauth_failure`.\n        # It contains a `%Ueberauth.Failure{}` struct.\n        # https://hexdocs.pm/ueberauth/Ueberauth.Failure.html#t:t/0\n        %{assigns: %{ueberauth_failure: %Failure{errors: [%Error{message: message} | _]}}} = conn,\n        _params\n      ) do\n    conn\n    |> put_flash(:error, message)\n    |> redirect(to: \"/\")\n  end\n\n  # If neither exist, just redirect home\n  def callback(conn, _params) do\n    redirect(conn, to: \"/\")\n  end\nend\n```","ref":"readme.html#controller","title":"Controller - ueberauth_mastodon","type":"extras"},{"doc":"Finally, you'll likely want to create a plug to authenticate the user on pageload.\nThis is one possible way:\n\n```elixir\ndefmodule PatronWeb.Plugs.BootstrapUser do\n  import Plug.Conn\n  alias Patron.User\n  alias Ueberauth.Auth.Credentials\n  alias Ueberauth.Strategy.Mastodon\n\n  @behaviour Plug\n\n  def init(_), do: nil\n\n  def call(conn, _) do\n    # Get the token set from the callback\n    case get_session(conn, :token_data) do\n      nil -> conn\n      # Make an HTTP request\n      %Credentials{token: token} -> verify_token(conn, token)\n      # Delete invalid token\n      _ -> delete_session(conn, :token_data)\n    end\n  end\n\n  # Fetch the account from the token\n  defp verify_token(conn, token) do\n    # The uid is an ActivityPub ID, which serves as a convenient base URL\n    with %Credentials{uid: ap_id} <- get_session(conn, :token_data),\n         {:ok, %{status: 200, body: %{\"url\" => ap_id} = data}} <-\n           Mastodon.API.account_verify_credentials(ap_id, token) do\n      conn\n      |> assign(:user_data, data)\n    else\n      _ -> delete_session(conn, :token_data)\n    end\n  end\nend\n```\n\nAnd in the router:\n\n```elixir\npipeline :browser do\n  # ...\n  plug PatronWeb.Plugs.BootstrapUser\nend\n```","ref":"readme.html#authentication-plug","title":"Authentication Plug - ueberauth_mastodon","type":"extras"},{"doc":"Add `ueberauth`, `ueberauth_mastodon`, and a Tesla adapter to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ueberauth, \"~> 0.7.0\"},\n    {:ueberauth_mastodon, \"~> 0.2.1\"},\n\n    # For `Tesla.Adapter.Hackney` to work\n    {:hackney, \"~> 1.18\"}\n  ]\nend\n```\n\n# License\n\nueberauth_mastodon is licensed under the MIT license.\nSee LICENSE.md for the full text.","ref":"readme.html#installation","title":"Installation - ueberauth_mastodon","type":"extras"},{"doc":"# MIT License\n\nCopyright (c) 2021 Alex Gleason\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"MIT License","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,50,53,46,53]}}